FLTK 1.4.4: Fl_Tile Class Reference

FLTK 1.4.4

Loading...
Searching...
No Matches
Fl_Tile Class Reference

The Fl_Tile class lets you resize its children by dragging the border between them. More...

Inheritance diagram for Fl_Tile:

## Classes
struct | Size_Range

## Public Member Functions
virtual void | drag_intersection (int oldx, int oldy, int newx, int newy)
| Drags the intersection at (`oldx`,`oldy`) to (`newx`,`newy`).
| Fl_Tile (int X, int Y, int W, int H, const char *L=0)
| Creates a new Fl_Tile widget using the given position, size, and label string.
int | handle (int event) FL_OVERRIDE
| Handles the specified event.
void | init_size_range (int default_min_w=-1, int default_min_h=-1)
| Initialize the size range mode of Fl_Tile and set the default minimum width and height.
virtual void | move_intersection (int oldx, int oldy, int newx, int newy)
| Drags the intersection at (`oldx`,`oldy`) to (`newx`,`newy`).
void | position (int oldx, int oldy, int newx, int newy)
void | position (int x, int y)
void | resize (int X, int Y, int W, int H) FL_OVERRIDE
| Resizes the Fl_Tile widget and its children.
void | size_range (Fl_Widget *w, int minw, int minh, int maxw=0x7FFFFFFF, int maxh=0x7FFFFFFF)
| Set the allowed size range for the give child widget.
void | size_range (int index, int minw, int minh, int maxw=0x7FFFFFFF, int maxh=0x7FFFFFFF)
| Set the allowed size range for the child at the given index.
| ~Fl_Tile () FL_OVERRIDE
| Destructor.
Public Member Functions inherited from Fl_Group
Fl_Widget *& | _ddfdesign_kludge ()
| This is for forms compatibility only.
void | add (Fl_Widget &)
| The widget is removed from its current group (if any) and then added to the end of this group.
void | add (Fl_Widget *o)
| See void Fl_Group::add(Fl_Widget &w).
void | add_resizable (Fl_Widget &o)
| Adds a widget to the group and makes it the resizable widget.
Fl_Widget *const * | array () const
| Returns a pointer to the array of children.
Fl_Group const * | as_group () const FL_OVERRIDE
Fl_Group * | as_group () FL_OVERRIDE
| Returns an Fl_Group pointer if this widget is an Fl_Group.
void | begin ()
| Sets the current group so you can build the widget tree by just constructing the widgets.
Fl_Widget * | child (int n) const
| Returns the n'th child.
int | children () const
| Returns how many child widgets the group has.
void | clear ()
| Deletes all child widgets from memory recursively.
unsigned int | clip_children ()
| Returns the current clipping mode.
void | clip_children (int c)
| Controls whether the group widget clips the drawing of child widgets to its bounding box.
virtual int | delete_child (int n)
| Removes the widget at `index` from the group and deletes it.
void | end ()
| Exactly the same as current(this->parent()).
int | find (const Fl_Widget &o) const
| See int Fl_Group::find(const Fl_Widget *w) const.
int | find (const Fl_Widget *) const
| Searches the child array for the widget and returns the index.
| Fl_Group (int, int, int, int, const char *=0)
| Creates a new Fl_Group widget using the given position, size, and label string.
void | focus (Fl_Widget *W)
void | forms_end ()
| This is for forms compatibility only.
void | init_sizes ()
| Resets the internal array of widget sizes and positions.
void | insert (Fl_Widget &, int i)
| The widget is removed from its current group (if any) and then inserted into this group.
void | insert (Fl_Widget &o, Fl_Widget *before)
| This does insert(w, find(before)).
void | remove (Fl_Widget &)
| Removes a widget from the group but does not delete it.
void | remove (Fl_Widget *o)
| Removes the widget `o` from the group.
void | remove (int index)
| Removes the widget at `index` from the group but does not delete it.
Fl_Widget * | resizable () const
| Returns the group's resizable widget.
void | resizable (Fl_Widget &o)
| Sets the group's resizable widget.
void | resizable (Fl_Widget *o)
| The resizable widget defines both the resizing box and the resizing behavior of the group and its children.
virtual | ~Fl_Group ()
| The destructor also deletes all the children.
Public Member Functions inherited from Fl_Widget
void | _clear_fullscreen ()
void | _set_fullscreen ()
void | activate ()
| Activates the widget.
unsigned int | active () const
| Returns whether the widget is active.
int | active_r () const
| Returns whether the widget and all of its parents are active.
Fl_Align | align () const
| Gets the label alignment.
void | align (Fl_Align alignment)
| Sets the label alignment.
long | argument () const
| Gets the current user data (long) argument that is passed to the callback function.
void | argument (long v)
| Sets the current user data (long) argument that is passed to the callback function.
virtual class Fl_Gl_Window * | as_gl_window ()
| Returns an Fl_Gl_Window pointer if this widget is an Fl_Gl_Window.
virtual class Fl_Gl_Window const * | as_gl_window () const
virtual Fl_Window * | as_window ()
| Returns an Fl_Window pointer if this widget is an Fl_Window.
virtual Fl_Window const * | as_window () const
void | bind_deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
void | bind_deimage (int f)
| Bind the inactive image to the widget, so the widget will delete the image when it is no longer needed.
void | bind_image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
void | bind_image (int f)
| Bind the image to the widget, so the widget will delete the image when it is no longer needed.
Fl_Boxtype | box () const
| Gets the box type of the widget.
void | box (Fl_Boxtype new_box)
| Sets the box type for the widget.
Fl_Callback_p | callback () const
| Gets the current callback function for the widget.
void | callback (Fl_Callback *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback *cb, Fl_Callback_User_Data *p, bool auto_free)
| Sets the current callback function and managed user data for the widget.
void | callback (Fl_Callback *cb, void *p)
| Sets the current callback function and data for the widget.
void | callback (Fl_Callback0 *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback1 *cb, long p=0)
| Sets the current callback function for the widget.
unsigned int | changed () const
| Checks if the widget value changed since the last callback.
void | clear_active ()
| Marks the widget as inactive without sending events or changing focus.
void | clear_changed ()
| Marks the value of the widget as unchanged.
void | clear_damage (uchar c=0)
| Clears or sets the damage flags.
void | clear_output ()
| Sets a widget to accept input.
void | clear_visible ()
| Hides the widget.
void | clear_visible_focus ()
| Disables keyboard focus navigation with this widget.
Fl_Color | color () const
| Gets the background color of the widget.
void | color (Fl_Color bg)
| Sets the background color of the widget.
void | color (Fl_Color bg, Fl_Color sel)
| Sets the background and selection color of the widget.
Fl_Color | color2 () const
| For back compatibility only.
void | color2 (unsigned a)
| For back compatibility only.
int | contains (const Fl_Widget *w) const
| Checks if w is a child of this widget.
void | copy_label (const char *new_label)
| Sets the current label.
void | copy_tooltip (const char *text)
| Sets the current tooltip text.
uchar | damage () const
| Returns non-zero if draw() needs to be called.
void | damage (uchar c)
| Sets the damage bits for the widget.
void | damage (uchar c, int x, int y, int w, int h)
| Sets the damage bits for an area inside the widget.
int | damage_resize (int, int, int, int)
| Internal use only.
void | deactivate ()
| Deactivates the widget.
Fl_Image * | deimage ()
| Gets the image that is used as part of the widget label when in the inactive state.
const Fl_Image * | deimage () const
| Gets the image that is used as part of the widget label when in the inactive state.
void | deimage (Fl_Image &img)
| Sets the image to use as part of the widget label when in the inactive state.
void | deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
int | deimage_bound () const
| Returns whether the inactive image is managed by the widget.
void | do_callback (Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with default arguments.
void | do_callback (Fl_Widget *widget, long arg, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
void | do_callback (Fl_Widget *widget, void *arg=0, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
void | draw_label (int, int, int, int, Fl_Align) const
| Draws the label in an arbitrary bounding box with an arbitrary alignment.
int | h () const
| Gets the widget height.
virtual void | hide ()
| Makes a widget invisible.
int | horizontal_label_margin ()
| Get the spacing between the label and the horizontal edge of the widget.
void | horizontal_label_margin (int px)
| Set the spacing between the label and the horizontal edge of the widget.
Fl_Image * | image ()
| Gets the image that is used as part of the widget label when in the active state.
const Fl_Image * | image () const
| Gets the image that is used as part of the widget label when in the active state.
void | image (Fl_Image &img)
| Sets the image to use as part of the widget label when in the active state.
void | image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
int | image_bound () const
| Returns whether the image is managed by the widget.
int | inside (const Fl_Widget *wgt) const
| Checks if this widget is a child of `wgt`.
int | is_label_copied () const
| Returns whether the current label was assigned with copy_label().
const char * | label () const
| Gets the current label text.
void | label (const char *text)
| Sets the current label pointer.
void | label (Fl_Labeltype a, const char *b)
| Shortcut to set the label text and type in one call.
int | label_image_spacing ()
| Return the gap size between the label and the image.
void | label_image_spacing (int gap)
| Set the gap between the label and the image in pixels.
Fl_Color | labelcolor () const
| Gets the label color.
void | labelcolor (Fl_Color c)
| Sets the label color.
Fl_Font | labelfont () const
| Gets the font to use.
void | labelfont (Fl_Font f)
| Sets the font to use.
Fl_Fontsize | labelsize () const
| Gets the font size in pixels.
void | labelsize (Fl_Fontsize pix)
| Sets the font size in pixels.
Fl_Labeltype | labeltype () const
| Gets the label type.
void | labeltype (Fl_Labeltype a)
| Sets the label type.
void | measure_label (int &ww, int &hh) const
| Sets width ww and height hh accordingly with the label size.
bool | needs_keyboard () const
| Returns whether this widget needs a keyboard.
void | needs_keyboard (bool needs)
| Sets whether this widget needs a keyboard.
unsigned int | output () const
| Returns if a widget is used for output only.
Fl_Group * | parent () const
| Returns a pointer to the parent widget.
void | parent (Fl_Group *p)
| Internal use only - "for hacks only".
void | position (int X, int Y)
| Repositions the window or widget.
void | redraw ()
| Schedules the drawing of the widget.
void | redraw_label ()
| Schedules the drawing of the label.
Fl_Color | selection_color () const
| Gets the selection color.
void | selection_color (Fl_Color a)
| Sets the selection color.
void | set_active ()
| Marks the widget as active without sending events or changing focus.
void | set_changed ()
| Marks the value of the widget as changed.
void | set_output ()
| Sets a widget to output only.
void | set_visible ()
| Makes the widget visible.
void | set_visible_focus ()
| Enables keyboard focus navigation with this widget.
int | shortcut_label () const
| Returns whether the widget's label uses '&' to indicate shortcuts.
void | shortcut_label (int value)
| Sets whether the widget's label uses '&' to indicate shortcuts.
virtual void | show ()
| Makes a widget visible.
void | size (int W, int H)
| Changes the size of the widget.
int | take_focus ()
| Gives the widget the keyboard focus.
unsigned int | takesevents () const
| Returns if the widget is able to take events.
int | test_shortcut ()
| Returns true if the widget's label contains the entered '&x' shortcut.
const char * | tooltip () const
| Gets the current tooltip text.
void | tooltip (const char *text)
| Sets the current tooltip text.
Fl_Window * | top_window () const
| Returns a pointer to the top-level window for the widget.
Fl_Window * | top_window_offset (int &xoff, int &yoff) const
| Finds the x/y offset of the current widget relative to the top-level window.
uchar | type () const
| Gets the widget type.
void | type (uchar t)
| Sets the widget type.
int | use_accents_menu ()
| Returns non zero if MAC_USE_ACCENTS_MENU flag is set, 0 otherwise.
void * | user_data () const
| Gets the user data for this widget.
void | user_data (Fl_Callback_User_Data *v, bool auto_free)
| Sets the user data for this widget.
void | user_data (void *v)
| Sets the user data for this widget.
int | vertical_label_margin ()
| Get the spacing between the label and the vertical edge of the widget.
void | vertical_label_margin (int px)
| Set the spacing between the label and the vertical edge of the widget.
unsigned int | visible () const
| Returns whether a widget is visible.
unsigned int | visible_focus () const
| Checks whether this widget has a visible focus.
void | visible_focus (int v)
| Modifies keyboard focus navigation.
int | visible_r () const
| Returns whether a widget and all its parents are visible.
int | w () const
| Gets the widget width.
Fl_When | when () const
| Returns the conditions under which the callback is called.
void | when (uchar i)
| Sets the flags used to decide when a callback is called.
Fl_Window * | window () const
| Returns a pointer to the nearest parent window up the widget hierarchy.
int | x () const
| Gets the widget position in its window.
int | y () const
| Gets the widget position in its window.
virtual | ~Fl_Widget ()
| Destroys the widget.

## Protected Member Functions
Fl_Cursor | cursor (int n)
| Returns the cursor for cursor index n.
int | on_insert (Fl_Widget *, int) FL_OVERRIDE
| Insert a new entry in the size range list.
int | on_move (int, int) FL_OVERRIDE
| Move the entry in the size range list.
void | on_remove (int) FL_OVERRIDE
| Remove the entry from the size range list.
void | request_grow_b (int old_b, int &new_b, Fl_Rect *final_size)
| Request for children to change their layout.
void | request_grow_l (int old_l, int &new_l, Fl_Rect *final_size)
| Request for children to change their layout.
void | request_grow_r (int old_r, int &new_r, Fl_Rect *final_size)
| Request for children to change their layout.
void | request_grow_t (int old_t, int &new_t, Fl_Rect *final_size)
| Request for children to change their layout.
void | request_shrink_b (int old_b, int &new_b, Fl_Rect *final_size)
| Request for children to change their layout.
void | request_shrink_l (int old_l, int &new_l, Fl_Rect *final_size)
| Request for children to change their layout.
void | request_shrink_r (int old_r, int &new_r, Fl_Rect *final_size)
| Request for children to change their layout.
void | request_shrink_t (int old_t, int &new_t, Fl_Rect *final_size)
| Request for children to change their layout.
void | set_cursor (int n)
| Set one of four cursors used for dragging etc…
Protected Member Functions inherited from Fl_Group
Fl_Rect * | bounds ()
| Returns the internal array of widget sizes and positions.
void | draw () FL_OVERRIDE
| Draws the widget.
void | draw_child (Fl_Widget &widget) const
| Forces a child to redraw.
void | draw_children ()
| Draws all children of the group.
void | draw_outside_label (const Fl_Widget &widget) const
| Parents normally call this to draw outside labels of child widgets.
int * | sizes ()
| Returns the internal array of widget sizes and positions.
void | update_child (Fl_Widget &widget) const
| Draws a child only if it needs it.
Protected Member Functions inherited from Fl_Widget
void | clear_flag (unsigned int c)
| Clears a flag in the flags mask.
void | draw_backdrop () const
| If FL_ALIGN_IMAGE_BACKDROP is set, the image or deimage will be drawn.
void | draw_box () const
| Draws the widget box according its box style.
void | draw_box (Fl_Boxtype t, Fl_Color c) const
| Draws a box of type t, of color c at the widget's position and size.
void | draw_box (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color c) const
| Draws a box of type t, of color c at the position X,Y and size W,H.
void | draw_focus () const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int X, int Y, int W, int H) const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color bg) const
| Draws a focus box for the widget at the given position and size.
void | draw_label () const
| Draws the widget's label at the defined label position.
void | draw_label (int, int, int, int) const
| Draws the label in an arbitrary bounding box.
| Fl_Widget (int x, int y, int w, int h, const char *label=0L)
| Creates a widget at the given position and size.
unsigned int | flags () const
| Gets the widget flags mask.
void | h (int v)
| Internal use only.
void | set_flag (unsigned int c)
| Sets a flag in the flags mask.
void | w (int v)
| Internal use only.
void | x (int v)
| Internal use only.
void | y (int v)
| Internal use only.

## Protected Attributes
int | cursor_
| current cursor index (0..3)
Fl_Cursor * | cursors_
| points at the array of 4 cursors (may be overridden)
int | default_min_h_
int | default_min_w_
Size_Range * | size_range_
int | size_range_capacity_
int | size_range_size_

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Group
static Fl_Group * | current ()
| Returns the currently active group.
static void | current (Fl_Group *g)
| Sets the current group.
Static Public Member Functions inherited from Fl_Widget
static void | default_callback (Fl_Widget *widget, void *data)
| The default callback for all widgets that don't set a callback.
static unsigned int | label_shortcut (const char *t)
| Returns the Unicode value of the '&x' shortcut in a given text.
static int | test_shortcut (const char *, const bool require_alt=false)
| Returns true if the given text `t` contains the entered '&x' shortcut.
Protected Types inherited from Fl_Widget
enum | { INACTIVE = 1<<0 , INVISIBLE = 1<<1 , OUTPUT = 1<<2 , NOBORDER = 1<<3 , FORCE_POSITION = 1<<4 , NON_MODAL = 1<<5 , SHORTCUT_LABEL = 1<<6 , CHANGED = 1<<7 , OVERRIDE = 1<<8 , VISIBLE_FOCUS = 1<<9 , COPIED_LABEL = 1<<10 , CLIP_CHILDREN = 1<<11 , MENU_WINDOW = 1<<12 , TOOLTIP_WINDOW = 1<<13 , MODAL = 1<<14 , NO_OVERLAY = 1<<15 , GROUP_RELATIVE = 1<<16 , COPIED_TOOLTIP = 1<<17 , FULLSCREEN = 1<<18 , MAC_USE_ACCENTS_MENU = 1<<19 , NEEDS_KEYBOARD = 1<<20 , IMAGE_BOUND = 1<<21 , DEIMAGE_BOUND = 1<<22 , AUTO_DELETE_USER_DATA = 1<<23 , MAXIMIZED = 1<<24 , POPUP = 1<<25 , USERFLAG3 = 1<<29 , USERFLAG2 = 1<<30 , USERFLAG1 = 1<<31 }
| flags possible values enumeration. More...

## Detailed Description

The Fl_Tile class lets you resize its children by dragging the border between them.

For the tiling to work correctly, the children of an Fl_Tile must cover the entire area of the widget, but must not overlap. This means that all children must touch each other at their edges, and no gaps can be left inside the Fl_Tile.

Fl_Tile does not normally draw any graphics of its own. The "borders" which can be seen in the snapshot above are actually part of the children. Their boxtypes have been set to FL_DOWN_BOX creating the impression of "ridges" where the boxes touch. What you see are actually two adjacent FL_DOWN_BOX's drawn next to each other. All neighboring widgets share the same edge - the widget's thick borders make it appear as though the widgets aren't actually touching, but they are. If the edges of adjacent widgets do not touch, then it will be impossible to drag the corresponding edges.

Note
  Fl_Tile works in two distinctive modes. In classic mode, the range of motion for edges and intersections is controlled using an invisible child that is marked as the resizable() widget of the tile group. Classic mode is described in detail a few paragraphs down.

## Fl_Tile size_range mode

By assigning a default minimum size to all children with Fl_Tile::init_size_range(int default_minimum_width, int default_minimum_height) or by assigning minimal sizes to individual children with size_range(Fl_Widget *child, int minimum_width, int minimum_height, int, int), the tile group is put into size_range operation mode.

In this mode, the child that is marked resizable() will behave as it would in a regular Fl_Group widget. When dragging edges or intersections with the mouse, Fl_Tile will ensure that none of the children shrinks to a size that is smaller than requested. When resizing the Fl_Tile group, size ranges are not enforced by the tile. Instead, the size range of the enclosing window should be limited to a valid range.

Tile does not differentiate between visible and invisible children. If children are created smaller than their assigned minimum size, dragging intersections may cause unexpected jumps in size. Zero width or height widget are not harmful, but should be avoided.

Example for a center document tile and two tool boxes on the left and right

Fl_Window win(400, 300, "My App");
Fl_Tile tile(0, 0, 400, 300);
Fl_Box left_tool_box(0, 0, 100, 300, "Tools");
left_tool_box.box(FL_DOWN_BOX);
tile.size_range(&left_tool_box, 50, 50);
Fl_Box document(100, 0, 200, 300, "Document");
document.box(FL_DOWN_BOX);
tile.size_range(&document, 100, 50);
Fl_Box right_tool_box(300, 0, 100, 300, "More\nTools");
right_tool_box.box(FL_DOWN_BOX);
tile.size_range(&right_tool_box, 50, 50);
tile.end();
tile.resizable(document);
win.end();
win.resizable(tile);
win.show(argc,argv);
win.size_range(200, 50);
FL_DOWN_BOX
@ FL_DOWN_BOX
see figure Standard Box Types
Definition Enumerations.H:649
Fl_Box
This widget simply draws its box, and possibly its label.
Definition Fl_Box.H:34
Fl_Tile::Fl_Tile
Fl_Tile(int X, int Y, int W, int H, const char *L=0)
Creates a new Fl_Tile widget using the given position, size, and label string.
Definition Fl_Tile.cxx:921
Fl_Window
This widget produces an actual window.
Definition Fl_Window.H:55

## Fl_Tile classic mode

Fl_Tile allows objects to be resized to zero dimensions. To prevent this you can use the resizable() to limit where corners can be dragged to. For more information see note below.

Even though objects can be resized to zero sizes, they must initially have non-zero sizes so the Fl_Tile can figure out their layout. If desired, call position() after creating the children but before displaying the window to set the borders where you want.

Note on resizable(Fl_Widget &w): The "resizable" child widget (which should be invisible) limits where the borders can be dragged to. All dragging will be limited inside the resizable widget's borders. If you don't set it, it will be possible to drag the borders right to the edges of the Fl_Tile widget, and thus resize objects on the edges to zero width or height. When the entire Fl_Tile widget is resized, the resizable() widget will keep its border distance to all borders the same (this is normal resize behavior), so that you can effectively set a border width that will never change. To ensure correct event delivery to all child widgets the resizable() widget must be the first child of the Fl_Tile widget group. Otherwise some events (e.g. FL_MOVE and FL_ENTER) might be consumed by the resizable() widget so that they are lost for widgets covered (overlapped) by the resizable() widget.

Note
  You can still resize widgets inside the resizable() to zero width and/or height, i.e. box 2b above to zero width and box 3a to zero height.

See also
  void Fl_Group::resizable(Fl_Widget &w)

Example for resizable with 20 pixel border distance:

int dx = 20, dy = dx;
Fl_Tile tile(50,50,300,300);
// create resizable() box first
Fl_Box r(tile.x()+dx,tile.y()+dy,tile.w()-2*dx,tile.h()-2*dy);
tile.resizable(r);
// ... create widgets inside tile (see test/tile.cxx) ...
tile.end();

See also the complete example program in test/tile.cxx.

## Constructor & Destructor Documentation

## ◆ Fl_Tile()

Fl_Tile::Fl_Tile | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | L = 0 )

Creates a new Fl_Tile widget using the given position, size, and label string.

The default boxtype is FL_NO_BOX.

The destructor also deletes all the children. This allows a whole tree to be deleted at once, without having to keep a pointer to all the children in the user code. A kludge has been done so the Fl_Tile and all of its children can be automatic (local) variables, but you must declare the Fl_Tile first, so that it is destroyed last.

See also
  class Fl_Group

## Member Function Documentation

## ◆ cursor()

Fl_Cursor Fl_Tile::cursor | ( | int | n | ) |
| inlineprotected

Returns the cursor for cursor index n.

See also
  Fl_Tile::set_cursor(int)

## ◆ drag_intersection()

void Fl_Tile::drag_intersection | ( | int | oldx,
|  | int | oldy,
|  | int | newx,
|  | int | newy )
| virtual

Drags the intersection at (`oldx`,`oldy`) to (`newx`,`newy`).

See also
  Fl_Tile::move_intersection(int oldx, int oldy, int newx, int newy) , but this method does not call init_sizes() and is used for interactive children layout using the mouse.

Parameters

  [in] | oldx,oldy | move the intersection at this coordinate, pass zero to disable drag in that direction.
  [in] | newx,newy | move the intersection as close to this new coordinate as possible

## ◆ handle()

int Fl_Tile::handle | ( | int | event | ) |
| virtual

Handles the specified event.

You normally don't call this method directly, but instead let FLTK do it when the user interacts with the widget.

When implemented in a widget, this function must return 0 if the widget does not use the event or 1 otherwise.

Most of the time, you want to call the inherited handle() method in your overridden method so that you don't short-circuit events that you don't handle. In this last case you should return the callee retval.

One exception to the rule in the previous paragraph is if you really want to override the behavior of the base class. This requires knowledge of the details of the inherited class.

In rare cases you may want to return 1 from your handle() method although you don't really handle the event. The effect would be to filter event processing, for instance if you want to dismiss non-numeric characters (keypresses) in a numeric input widget. You may "ring the bell" or show another visual indication or drop the event silently. In such a case you must not call the handle() method of the base class and tell FLTK that you consumed the event by returning 1 even if you didn't do anything with it.

Parameters

  [in] | event | the kind of event received

Return values

  0 | if the event was not used or understood
  1 | if the event was used and can be deleted

See also
  Fl_Event

Reimplemented from Fl_Group.

## ◆ init_size_range()

void Fl_Tile::init_size_range | ( | int | default_min_w = -1,
|  | int | default_min_h = -1 )

Initialize the size range mode of Fl_Tile and set the default minimum width and height.

The default minimum width and height is the size of the mouse pointer grab area at about 4 pixel units.

Parameters

  [in] | default_min_w,default_min_h | default size range for widgets that don't have an individual range assigned

## ◆ move_intersection()

void Fl_Tile::move_intersection | ( | int | oldx,
|  | int | oldy,
|  | int | newx,
|  | int | newy )
| virtual

Drags the intersection at (`oldx`,`oldy`) to (`newx`,`newy`).

This redraws all the necessary children.

If no size ranges are set, the new intersection position is limited to the size of the tile group. The resizable() option is not taken into account here.

If size ranges are set, the actual new position of the intersection will depend on the size range of every individual child. No child will be smaller than their minw and minh. After the new position is found, move_intersection() will call init_sizes(). The resizable() range is ignored.

Parameters

  [in] | oldx,oldy | move the intersection at this coordinate, pass zero to disable drag in that direction.
  [in] | newx,newy | move the intersection as close to this new coordinate as possible

## ◆ on_insert()

int Fl_Tile::on_insert | ( | Fl_Widget * | candidate,
|  | int | index )
| protectedvirtual

Insert a new entry in the size range list.

Reimplemented from Fl_Group.

## ◆ on_move()

int Fl_Tile::on_move | ( | int | oldIndex,
|  | int | newIndex )
| protectedvirtual

Move the entry in the size range list.

Reimplemented from Fl_Group.

## ◆ on_remove()

void Fl_Tile::on_remove | ( | int | index | ) |
| protectedvirtual

Remove the entry from the size range list.

Reimplemented from Fl_Group.

## ◆ position()

void Fl_Tile::position | ( | int | oldx,
|  | int | oldy,
|  | int | newx,
|  | int | newy )
| inline

Deprecated
  "since 1.4.0 - use move_intersection(p) instead"

## ◆ request_grow_b()

void Fl_Tile::request_grow_b | ( | int | old_b,
|  | int & | new_b,
|  | Fl_Rect * | final_size )
| protected

Request for children to change their layout.

Parameters

  [in] | old_b | grow all children with this current bottom edge toward the bottom edge of this tile
  [in,out] | new_b | try to grow to this coordinate, return the maximum possible growth (currently maxh is ignored, so we always grow to new_b)
  [in,out] | final_size | write the new position and size of all affected children into this list of Fl_Rect

## ◆ request_grow_l()

void Fl_Tile::request_grow_l | ( | int | old_l,
|  | int & | new_l,
|  | Fl_Rect * | final_size )
| protected

Request for children to change their layout.

Parameters

  [in] | old_l | grow all children with this current left edge toward the left edge of this tile
  [in,out] | new_l | try to grow to this coordinate, return the maximum possible growth (currently maxw is ignored, so we always grow to new_l)
  [in,out] | final_size | write the new position and size of all affected children into this list of Fl_Rect

## ◆ request_grow_r()

void Fl_Tile::request_grow_r | ( | int | old_r,
|  | int & | new_r,
|  | Fl_Rect * | final_size )
| protected

Request for children to change their layout.

Parameters

  [in] | old_r | grow all children with this current right edge toward the right edge of this tile
  [in,out] | new_r | try to grow to this coordinate, return the maximum possible growth (currently maxw is ignored, so we always grow to new_r)
  [in,out] | final_size | write the new position and size of all affected children into this list of Fl_Rect

## ◆ request_grow_t()

void Fl_Tile::request_grow_t | ( | int | old_t,
|  | int & | new_t,
|  | Fl_Rect * | final_size )
| protected

Request for children to change their layout.

Parameters

  [in] | old_t | grow all children with this current top edge toward the top edge of this tile
  [in,out] | new_t | try to grow to this coordinate, return the maximum possible growth (currently maxh is ignored, so we always grow to new_t)
  [in,out] | final_size | write the new position and size of all affected children into this list of Fl_Rect

## ◆ request_shrink_b()

void Fl_Tile::request_shrink_b | ( | int | old_b,
|  | int & | new_b,
|  | Fl_Rect * | final_size )
| protected

Request for children to change their layout.

See also
  Fl_Tile::request_shrink_l(int old_l, int &new_l, Fl_Rect *final_size)

Parameters

  [in] | old_b | shrink all children with this current bottoom edge toward the top edge of this tile
  [in,out] | new_b | try to shrink to this coordinate, return the maximum possible shrinkage
  [in,out] | final_size | if not NULL, write the new position and size of all affected children into this list of Fl_Rect

## ◆ request_shrink_l()

void Fl_Tile::request_shrink_l | ( | int | old_l,
|  | int & | new_l,
|  | Fl_Rect * | final_size )
| protected

Request for children to change their layout.

drag_intersection requests that all children with the left edge at old_l to shrink to new_l towards the right side of the tile. If the child can not shrink by that amount, it will ask all other children that touch its right side to shrink by the remainder (recursion). new_l will return the the maximum possible value while maintaining minimum width for all children involved.

request_shrink_r asks children to shrink toward the left, so that their right edge is as close as possible to new_r. request_shrink_t and request_shrink_b provide the same functionality for vertical resizing.

Parameters

  [in] | old_l | shrink all children with this current left edge
  [in,out] | new_l | try to shrink to this coordinate, return the maximum possible shrinkage
  [in,out] | final_size | if not NULL, write the new position and size of all affected children into this list of Fl_Rect

## ◆ request_shrink_r()

void Fl_Tile::request_shrink_r | ( | int | old_r,
|  | int & | new_r,
|  | Fl_Rect * | final_size )
| protected

Request for children to change their layout.

See also
  Fl_Tile::request_shrink_l(int old_l, int &new_l, Fl_Rect *final_size)

Parameters

  [in] | old_r | shrink all children with this current right edge toward the left edge of this tile
  [in,out] | new_r | try to shrink to this coordinate, return the maximum possible shrinkage
  [in,out] | final_size | if not NULL, write the new position and size of all affected children into this list of Fl_Rect

## ◆ request_shrink_t()

void Fl_Tile::request_shrink_t | ( | int | old_t,
|  | int & | new_t,
|  | Fl_Rect * | final_size )
| protected

Request for children to change their layout.

See also
  Fl_Tile::request_shrink_l(int old_l, int &new_l, Fl_Rect *final_size)

Parameters

  [in] | old_t | shrink all children with this current top edge toward the bottom edge of this tile
  [in,out] | new_t | try to shrink to this coordinate, return the maximum possible shrinkage
  [in,out] | final_size | if not NULL, write the new position and size of all affected children into this list of Fl_Rect

## ◆ resize()

void Fl_Tile::resize | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H )
| virtual

Resizes the Fl_Tile widget and its children.

Fl_Tile implements its own resize() method. It does not use Fl_Group::resize() to resize itself and its children.

In size_range mode, the child marked resizable() is resized first. Only if its minimum size is reached, other widgets in the tile will resize too.

In classic mode or when no resizable child is set, enlarging works by moving the lower-right corner and resizing the bottom and right border widgets accordingly.

Shrinking the Fl_Tile works in the opposite way by shrinking the bottom and right border widgets, unless they are reduced to zero width or height, resp. or to their minimal sizes defined by the resizable() widget. In this case other widgets will be shrunk as well.

See the Fl_Tile class documentation about how the resizable() works.

Reimplemented from Fl_Group.

## ◆ set_cursor()

void Fl_Tile::set_cursor | ( | int | n | ) |
| protected

Set one of four cursors used for dragging etc…

Fl_Tile uses an array of four cursors that are set depending on user actions:

- 0: normal cursor
- 1: horizontal dragging
- 2: vertical dragging
- 3: dragging an intersection

This method sets the window cursor for the given index `n`.

## ◆ size_range() [1/2]

void Fl_Tile::size_range | ( | Fl_Widget * | w,
|  | int | minw,
|  | int | minh,
|  | int | maxw = 0x7FFFFFFF,
|  | int | maxh = 0x7FFFFFFF )

Set the allowed size range for the give child widget.

Fl_Tile currently supports only the minimal width and height setting.

Parameters

  [in] | w | set the range for this child widget
  [in] | minw,minh | minimum width and height for that child
  [in] | maxw,maxh | maximum size, defaults to infinite, currently ignored

## ◆ size_range() [2/2]

void Fl_Tile::size_range | ( | int | index,
|  | int | minw,
|  | int | minh,
|  | int | maxw = 0x7FFFFFFF,
|  | int | maxh = 0x7FFFFFFF )

Set the allowed size range for the child at the given index.

Fl_Tile currently supports only the minimal width and height setting.

Parameters

  [in] | index | set the range for the child at this index
  [in] | minw,minh | minimum width and height for that child
  [in] | maxw,maxh | maximum size, defaults to infinite, currently ignored

The documentation for this class was generated from the following files:

- Fl_Tile.H
- Fl_Tile.cxx